/**
 * A record mapping the id or alias of a given language to the title of that id or alias.
 *
 * Note: This record is automatically generated by the build process.
 */
export const knownTitles: Readonly<Partial<Record<string, string>>> = /* title_placeholder[ */{}/* ] */;

/**
 * Tries to guess the name of a language given its id.
 *
 * @param name The language id.
 */
function guessTitle(name: string): string {
	return (name.substring(0, 1).toUpperCase() + name.substring(1)).replace(/s(?=cript)/, 'S');
}

/**
 * Returns the title of a known language id or alias.
 *
 * If the given name is not a known language, then a guessed title will be returned.
 */
export function getTitle(name: string): string {
	return knownTitles[name] || guessTitle(name);
}
